'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.SingleSwitchTypeRender = undefined;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _reactAtomLabel = require('@s-ui/react-atom-label');

var _reactAtomLabel2 = _interopRequireDefault(_reactAtomLabel);

var _helpers = require('./helpers');

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var SingleSwitchTypeRender = exports.SingleSwitchTypeRender = function SingleSwitchTypeRender(_ref) {
  var disabled = _ref.disabled,
      isFocus = _ref.isFocus,
      isToggle = _ref.isToggle,
      label = _ref.label,
      labelOptionalText = _ref.labelOptionalText,
      name = _ref.name,
      onBlur = _ref.onBlur,
      onFocus = _ref.onFocus,
      onKeyDown = _ref.onKeyDown,
      onToggle = _ref.onToggle,
      size = _ref.size,
      type = _ref.type;

  return _react2.default.createElement(
    'div',
    {
      className: (0, _helpers.workClassNames)(size, type, 'singleType', isToggle, isFocus, disabled),
      onClick: function onClick() {
        return onToggle();
      }
    },
    _react2.default.createElement(
      'div',
      {
        className: (0, _helpers.prefixClass)('container'),
        tabIndex: '0',
        onKeyDown: onKeyDown,
        onFocus: onFocus,
        onBlur: onBlur
      },
      _react2.default.createElement(_reactAtomLabel2.default, { name: name, text: label, optionalText: labelOptionalText }),
      _react2.default.createElement(
        'div',
        { className: (0, _helpers.prefixClass)('inputContainer') },
        _react2.default.createElement('div', {
          className: (0, _classnames2.default)((0, _helpers.prefixClass)('circle'), {
            'sui-AtomSwitch--toggle': isToggle
          })
        })
      )
    )
  );
};

SingleSwitchTypeRender.displayName = 'SingleSwitchTypeRender';

SingleSwitchTypeRender.propTypes = process.env.NODE_ENV !== "production" ? process.env.NODE_ENV !== "production" ? {
  /**
   * Form element name
   */
  name: _propTypes2.default.string,
  /**
   * The label itself. Proxy from label
   */
  label: _propTypes2.default.string,
  /**
   * The optional label text. Proxy from label
   */
  labelOptionalText: _propTypes2.default.string,
  /**
   * Size of switch: 'default', 'large'
   */
  size: _propTypes2.default.oneOf(['default', 'large']),
  /**
   * Type of switch: 'toggle' (default), 'select', 'single'
   */
  type: _propTypes2.default.oneOf(['toggle', 'select', 'single']),
  /**
   * Is Input disabled?
   */
  disabled: _propTypes2.default.bool,
  /**
   * Is component toggle
   */
  isToggle: _propTypes2.default.bool,
  /**
   * Is component focus
   */
  isFocus: _propTypes2.default.bool,
  /**
   * Callback on focus element
   */
  onFocus: _propTypes2.default.func,
  /**
   * Callback on toggle element
   */
  onBlur: _propTypes2.default.func,
  /**
   * Callback on toggle element
   */
  onToggle: _propTypes2.default.func,
  /**
   * Callback on keydown on the switch
   */
  onKeyDown: _propTypes2.default.func
} : {} : {};