'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.TYPES = exports.SIZES = exports.BASE_CLASS = undefined;

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _toggle = require('./SwitchType/toggle');

var _single = require('./SwitchType/single');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var BASE_CLASS = exports.BASE_CLASS = 'sui-AtomSwitch';

var SIZES = exports.SIZES = {
  DEFAULT: 'default',
  LARGE: 'large'
};

var TYPES = exports.TYPES = {
  TOGGLE: 'toggle',
  SELECT: 'select',
  SINGLE: 'single'
};

var SUPPORTED_KEYS = [' ', 'Enter', 'Spacebar'];

var AtomSwitch = function (_Component) {
  (0, _inherits3.default)(AtomSwitch, _Component);

  function AtomSwitch() {
    var _ref;

    var _temp, _this, _ret;

    (0, _classCallCheck3.default)(this, AtomSwitch);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = (0, _possibleConstructorReturn3.default)(this, (_ref = AtomSwitch.__proto__ || (0, _getPrototypeOf2.default)(AtomSwitch)).call.apply(_ref, [this].concat(args))), _this), _this.state = {
      isToggle: _this.props.initialValue,
      isFocus: false
    }, _this._onKeyDown = function (event) {
      if (_this.props.disabled === true) return;

      if (SUPPORTED_KEYS.includes(event.key)) {
        _this._onToggle();
        event.preventDefault();
      }
    }, _this._onToggle = function (forceValue) {
      var stateToggle = _this.state.isToggle;
      var onToggle = _this.props.onToggle;

      var isToggle = forceValue !== undefined ? forceValue : !stateToggle;
      _this.setState({ isToggle: isToggle }, function () {
        return onToggle(isToggle);
      });
    }, _this._onBlur = function () {
      _this.setState({ isFocus: false });
    }, _this._onFocus = function () {
      _this.setState({ isFocus: true });
    }, _temp), (0, _possibleConstructorReturn3.default)(_this, _ret);
  }

  (0, _createClass3.default)(AtomSwitch, [{
    key: 'render',
    value: function render() {
      var _state = this.state,
          isToggle = _state.isToggle,
          isFocus = _state.isFocus;


      var commonProps = (0, _extends3.default)({}, this.props, {
        isFocus: isFocus,
        isToggle: isToggle,
        onBlur: this._onBlur,
        onFocus: this._onFocus,
        onKeyDown: this._onKeyDown,
        onToggle: this._onToggle
      });

      return this.props.type === TYPES.SINGLE ? _react2.default.createElement(_single.SingleSwitchTypeRender, commonProps) : _react2.default.createElement(_toggle.ToggleSwitchTypeRender, commonProps);
    }
  }]);
  return AtomSwitch;
}(_react.Component);

AtomSwitch.displayName = 'AtomSwitch';

AtomSwitch.propTypes = process.env.NODE_ENV !== "production" ? process.env.NODE_ENV !== "production" ? {
  /**
   * Wheter switch is checked on init
   */
  initialValue: _propTypes2.default.bool,
  /**
   * Size of switch: 'default', 'large'
   */
  size: _propTypes2.default.oneOf([SIZES.DEFAULT, SIZES.LARGE]),
  /**
   * Type of switch: 'toggle' (default), 'select', 'single'
   */
  type: _propTypes2.default.oneOf([TYPES.TOGGLE, TYPES.SELECT, TYPES.SINGLE]),
  /**
   * Is Input disabled?
   */
  disabled: _propTypes2.default.bool,
  /**
   * Left label to be printed
   */
  labelLeft: _propTypes2.default.string,
  /**
   * Right label to be printed
   */
  labelRight: _propTypes2.default.string,
  /**
   * Form element name
   */
  name: _propTypes2.default.string.isRequired,
  /**
   * The label itself. Proxy from label
   */
  label: _propTypes2.default.string.isRequired,
  /**
   * The optional label text. Proxy from label
   */
  labelOptionalText: _propTypes2.default.string,
  /**
   * Callback to be called when switch. Flag whenever switch is active or not sent
   */
  onToggle: _propTypes2.default.func.isRequired
} : {} : {};

AtomSwitch.defaultProps = {
  disabled: false,
  initialValue: false,
  labelLeft: 'Off',
  labelRight: 'On',
  size: SIZES.DEFAULT,
  type: TYPES.TOGGLE
};

exports.default = AtomSwitch;